"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// import Serializer from "./parser/serializer";
const parser_1 = __importDefault(require("./parser/parser"));
const path_1 = __importDefault(require("path"));
const fs_1 = require("fs");
const util_1 = require("./util");
const { data: game } = parser_1.default.parse(fs_1.readFileSync(path_1.default.join(__dirname, '../gists/_skipping-stones_d6fd6fcf84de185e2584/script.txt'), 'utf-8'));
// Find the 'player'
const playerSprites = game.getPlayer().getSprites();
// Now, figure out which sprites interact with the player.
// This occurs in 2 ways:
// - same collisionlayer as the player sprites (maybe)
// - occurs on the left-hand-side of a rule with the player
const interactsWithPlayer = new Set(playerSprites);
game.rules.forEach(rule => {
    for (const sprites of rule.a11yGetConditionSprites()) {
        if (util_1.setIntersection(sprites, interactsWithPlayer).size > 0) {
            for (const sprite of sprites) {
                interactsWithPlayer.add(sprite);
            }
        }
    }
});
console.log('These sprites interact with the player');
console.log([...interactsWithPlayer].map(s => s.getName()));
console.log('These sprites do NOT interact with the player');
console.log([...util_1.setDifference(new Set(game.objects), interactsWithPlayer)].map(s => s.getName()));
// // Dump the game out to inspect
// const s = new Serializer(game)
// const graph = s.toJson()
// delete graph.sounds // circular dependency for stringifying
// delete graph.levels // just clutter
// delete graph.rules // just clutter
// console.log(JSON.stringify(graph, null, 2))
//# sourceMappingURL=_dependencyGraph.js.map